/**
 * @file
 * @mainpage SSTS -- The (Super) Simple Type System
 * @author Gustav Hartvigsson
 * @version 0.0.1-bzr (dev)
 * 
 * @section About
 * The (Super) Simple Type System is -- yet -- only an experiment. The base
 * for (almost) all objects in the system are derived from @ref SObject .
 * 
 * 
 * 
 */

#pragma once

#include "config.h"

#include "baseobject.h"
#include "Box.h"
#include "Callback.h"
#include "defs.h"
#include "DynamicArray.h"
#include "LinkedList.h"
#include "Error.h"
#include "Func.h"
#include "hash.h"
#include "Interface.h"
#include "MainLoop.h"
#include "Map.h"
#include "Matrix.h"
#include "utils.h"
#include "BaseN.h"


S_BEGIN_DECLS

S_UNUSED
static char *
__LIBSSTS__LICENSE__[] = {
"Copyright (c) 2013-2016 Gustav Hartvigsson\n"
"\n"
"Permission is hereby granted, free of charge, to any person obtaining a copy "
"of this software and associated documentation files (the \"Software\"), to deal "
"in the Software without restriction, including without limitation the rights "
"to use, copy, modify, merge, publish, distribute, sublicense, and/or sell "
"copies of the Software, and to permit persons to whom the Software i "
"furnished to do so, subject to the following conditions: \n"
"\n"
"The above copyright notice and this permission notice shall be included in "
"all copies or substantial portions of the Software. \n"
"\n"
"THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR \n"
"IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, "
"FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE "
"AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER "
"LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, "
"OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN "
"THE SOFTWARE.\n",
0x0,
0x0
};

S_UNUSED
static char *
__LIBSSTS__AUTHOR__[] = {
"(2013-2016) Gustav Hartvigsson <+GustavHartvigsson><gustav.hartvigsson@gmail.com>",
0x0,
0x0
};

S_UNUSED
static char * __LIBSSTS__INFO__[] = {
"Library Name: libssts",
"Library Full Name: Super Simple Type System",
"libssts is a simpel, \"object\" system in the style of GObject. The library "
"has main loop functionallity and some data structures like DynamicArray and "
"LinkedList. It is very versetile and what not. Have fun!",
0x0,
0x0
};

/**
 * Returns a string representing the current version.
 */
S_EXPORTED
char *
s_get_version_string ();

/**
 * Returns the Major version as on int.
 */
S_EXPORTED
int
s_get_version_major ();

/**
 * Returns the Minor version as on int.
 */
S_EXPORTED
int
s_get_version_minor ();

/**
 * Returns the Patch version as on int.
 */
S_EXPORTED
int
s_get_version_patch ();


S_END_DECLS
