
#include "Stream.h"
#include "StreamPrivate.h"

schar *
_s_stream_method_to_string (SStream * self);

SStream *
s_stream_new () {
  SStream * self = s_malloc (sizeof (SStream));
  SStreamClass * klass = s_malloc (sizeof (SStreamClass));
  self->priv = s_malloc (sizeof (SStreamPrivate));
  
  /* Lock as fast as we can. Prevents any issues. */
  self->priv->mutex = s_mutex_new ();
  s_mutex_lock (self->priv->mutex);
  
  s_stream_internal_initialize (klass);
  
  s_object_set_class (S_OBJECT (self), S_OBJECT_CLASS (klass));
  s_object_set_to_string_method (S_OBJECT (self),
                                 TO_STRING_FUNC (_s_stream_method_to_string));
  
  
  s_mutex_unlock (self->priv->mutex);
  return self;
}

size_t
s_stream_get_beffered (SStream * self) {
  return self->priv->buffered;
}

schar *
_s_stream_method_to_string (SStream * self) {
  return s_string_new_fmt ("(SStream: refcount: %d, buffered: %d)",
                           s_object_get_refcount (S_OBJECT (self)),
                           s_stream_get_beffered (self));
}

void
s_stream_write (SStream * self, size_t len, sbyte * data) {
  s_mutex_lock (self->priv->mutex);
  
  SStreamClass * klass = S_STREAM_CLASS (s_object_get_class (S_OBJECT(self)));
  
  klass->writer (self, len, data);
  
  s_mutex_unlock (self->priv->mutex);
}

sbyte *
s_stream_read (SStream * self, size_t len) {
  s_mutex_lock (self->priv->mutex);
  
  sbyte * bytes = NULL;
  
  SStreamClass * klass = S_STREAM_CLASS (s_object_get_class (S_OBJECT(self)));
  
  bytes = klass->reader (self, len);
  
  s_mutex_unlock (self->priv->mutex);
  
  return bytes;
}

void
s_stream_internal_initialize (SStreamClass * klass) {
  klass->writer = s_stream_internal_write;
  klass->reader = s_stream_internal_read;
}

void
s_stream_internal_write (SStream * self, size_t len, sbyte * data) {
  
  
  
}

sbyte *
s_stream_internal_read (SStream * self, size_t len) {
  sbyte * bytes = NULL;
  
  
  return bytes;
}




